;------------------------------------HISTORY----------------------------------
;(c) Ilya Mamontov, 2009
;  FILENAME: Synth.asm
;  DESCRIPTION: .
;               6 -.
;               _synth_procedure    512 
;  NOTE:
;------------------------------------------------------------------------------

include "m8c.inc"
include "PSoCAPI.inc"
include "SDCard.inc"
include "Synth.inc"

;------------------------------------------------------------------------------
area bss(RAM,REL,CON)
BASE:	equ	Counter8_1_COUNTER_REG	; 1-  (   !)
CNUM:	equ	6						;  (-)  
;------------------------
; Variable Allocation
;------------------------
startupcnt::BLK 2	;     (       PLL)
tickcnt:	BLK 1	;     (   )
;   
keys::		BLK 4	;    (  )
mask::		BLK 2	;   
keycnt::	BLK 1	; 
mode::		BLK 1	;bit 0 =     (0 -   )
					;bit 1 =   1-   UART (    )
					;bit 2 =      (  UART)
;  -
adr1::		BLK 2	;     FLASH
tempo:		BLK 1	;  
cnt:		BLK 1	;  
delay:		BLK 2	;     
tmp1::		BLK 1	;1- 
tmp2:		BLK 1	;2- 
flag:		BLK 1		;    
array:		BLK CNUM*4	;      (  )
icnt:		BLK 1		; -   

cntDebug::	BLK 1	;!!!debug

area text(ROM,REL)
;------------------------------------------------------------------------------
;      A
;------------------------------------------------------------------------------
synth_load_code::
;	mov X,[adr1+0]	;  
;	mov A,[adr1+1]	;  
;	romx
	mov X,[ptrR]
	mov A,[X]
	ret
;------------------------------------------------------------------------------
;      	(A=0  ,  A  )
;------------------------------------------------------------------------------
synth_increment::
;	inc [adr1+0]	;  1  
;	adc [adr1+1],0	;       

	inc [ptrR]		;  1 
	cmp [ptrR],buff+BUFFERSIZE*BUFFNUMBER	;    ?
	jc .skip
		mov [ptrR],buff					;,    
	.skip:
	ret
;------------------------------------------------------------------------------
;     ,   
;------------------------------------------------------------------------------
synth_init::
	;   
	mov [delay+0],0
	mov [delay+1],0
	mov [tempo],8	;   (120   )     512 
	mov [cnt],1

	;      ( FLASH   SD Card)
	;mov [adr1+0],(<track1)	;   ,      
	;mov [adr1+1],(>track1)
	;add [adr1+0],2			;  2  ( )
	;adc [adr1+1],0

	mov [ptrR],buff
	mov [ptrW],buff
	ret
;------------------------------------------------------------------------------
;      (   0)
;------------------------------------------------------------------------------
synth_notes_off::
	mov X,(CNUM*4-4)	; ,   4
	.reset:
		mov A,0
		mov [X+array+2],A
		mov reg[X+BASE+2],A
		dec X
		jc .end_reset	; 0 -  	
		dec X
		dec X
		dec X
		jmp .reset	
	.end_reset:	
	ret
;-----------------------------------------------------------------------------
;    -   
;
;    - 20:126 (x6,3)  50   (100 )    
;   630    
;-----------------------------------------------------------------------------
Column_0_Int::
	push A
	push X
	;   -    
	M8C_SetBank1
	xor reg[ALT_CR0],0b00001111	;LUT: c "A"  "not A"
	M8C_SetBank0
	; -    
	mov [tickcnt],0				; -
	jmp stage2


;-----------------------------------------------------------------------------
;   -     (512 )
;-----------------------------------------------------------------------------
synth_procedure::
	push A
	push X

;--------------  1   PLL (  16 )---------------
	dec [startupcnt+0]			; 
	sbb [startupcnt+1],0
	jnc no_startupcnt
    		M8C_SetBank1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    		or reg[OSC_CR0],0x40; PLL
    		;(FCPU  3  ,    (10-50 ),   -   )
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    		M8C_SetBank0
	no_startupcnt:



;stage0: ------------------------   -------------------------------
	synth_keyscan		;     ( "Synth.inc")

;stage1: --------- -   - ------------------
stage1:
	mov [icnt],0
chn_loop:
	mov X,[icnt]
	;-  ,  X
	cmp	[X+array+2],0	;  ?
	jnz atack			;,   
		mov A,0			; - ( )     0
		jmp writePWM
	atack:
	mov A,reg[X+BASE+2]	;  
	cmp	A,[X+array+2]	;    
	jnc skip_writePWM
		inc A			;  -    1 
	writePWM:
	mov reg[X+BASE+2],A	;   
	skip_writePWM:
	add [icnt],4		; CNUM-
	cmp [icnt],CNUM*4
	jc chn_loop



	;-------------   ------------------
	tst [mode],4+1		; 
	jnz stage2			;       Play - 
		;    (   )
		;         
		inc [tickcnt]				;  
		sbb [tickcnt],0				;max  = 255
		cmp [tickcnt],100
		jnz .no_noteoff				;<100
			call synth_notes_off	;  
		.no_noteoff:
		pop X
		pop A
		reti

;stage2:-----------------------     -----------------------------
stage2:
	;   ( )
	dec [cnt]
	jz .cnt_is_complete
		pop X
		pop A
		reti
	.cnt_is_complete: 
	; 
	mov [cnt],[tempo]	;    Play ( =8  120   )
	tst [mode],1		; 
	jnz .skip			;   Play,  
		mov [cnt],9	;     (1     )   
	.skip:

;stage3:------------------   (  ) -----------------------
stage3:
	; 
	dec [delay+0]
	sbb [delay+1],0
	jc .delay_is_complete
		pop X
		pop A
		reti
	.delay_is_complete:

;------------------  ,     -------------
again:
	;---- ,       ------
	mov [delay+0],0	;    
	mov [delay+1],0

	mov A,[ptrW]
	sub A,[ptrR]
	jnc .skip_corr	;  ptrR <= ptrW
		add A,BUFFERSIZE*BUFFNUMBER
	.skip_corr:
	cmp A,2
	jnc .data_ready	;  2   
		cmp A,1
		jnz .skip_check	;    -   
			call synth_load_code	;  0  
			jz synth_end			; 0,    
		.skip_check:
		pop X
		pop A
		reti
	.data_ready:


;stage4:--------------------------------------------------------------------------------
; :  0xxx xxxx,  1xxx xxxx, ... ... 1xxx xxxx,  1xxx xxxx, ... 0, 0
;                 .  . .             (. ,  )
;----------------------------------------------------------------------------------------
	
	; 1- -      
	call synth_load_code	;    A
	call synth_increment	; 
	cmp A,0
	jz synth_end			; 0,    

	mov [tmp1],A		; 
	asl A				;. . 
	jnc process_cmd		; .=0,      

	;    
	mov [delay+0],A		;    (2)
	;     A
	call synth_load_code	;    A
	mov [delay+1],A		;    (2)
	asl A				;. . 	
	jc msb				; = 1,   -   
	mov [delay+1],0		; = 0,    ,    0
msb:
	rrc [delay+1]		;  2 ("")  
	rrc [delay+0]		;
	and [delay+1],0x3F	;   
	pop X
	pop A
	reti

process_cmd: 
	;   (2- )
	call synth_load_code	;  ".- "
	call synth_increment

process_UART::	;       UART ( )
				;. : [tmp1] = 1- , A = 2- , bit 2  [mode] = 1   

	mov [tmp2],A	;  
	asl A			;. . 
	jnc skip_note	;  -  

	;  
	cmp [tmp1],0x0E		;" "?
	jnz set_note 
	mov A,[tmp2]		;  
	and A,0x7F			;  7
	mov [tempo],A		;  
	jmp skip_note


set_note: 
	; .   (   4),  : 0,1,2...
	asl A			; 2
	and A,0x3C		;  
	;   -   		
		cmp A,(CNUM*4)
		jnc skip_note	;   CNUM   
	mov X,A				; .  

	;  (..  Clk)
	mov [flag],0		;  ( 6  7   ,   )
	mov A,[tmp1]		;   -  A 
	and A,0x70			;  
	;  C0..C1..C2..
	cmp A,0x30			;3   ?
	jnc yes_3
	mov A,0x12			; Clk  0..2  (Broadcast net)
	jmp set_clk
yes_3:
	;  3..4..5..
	cmp A,0x30			;3 ?
	jnz no_3
	mov A,0x12			; Clk  3  (Broadcast net)
	jmp set_clk
no_3:
	cmp A,0x40			;4 ?
	jnz no_4
	mov A,0x1E			; Clk  4  (Row input 2)
	jmp set_clk
no_4:
	cmp A,0x50			;5 ?
	jnz no_5
	mov A,0x16			; Clk  5  (VC2)
	jmp set_clk
	;  C6..C7..
no_5:
	inc [flag]			; flag=1 ( 6 )
	cmp A,0x60			;6 ?
	jnz no_6
	mov A,0x16			; Clk  6  (VC2)
	jmp set_clk
no_6:
	inc [flag]			; flag=2 ( 7 )
	mov A,0x16			; Clk  7  (VC2)
	;  Clk
set_clk:
	M8C_SetBank1
	mov reg[X+BASE+1],A	; .-  
	M8C_SetBank0
skip_clk:

	;  (..       )
	mov A,[tmp1]		;   
	and A,0x0F			; . 4 
	index p_table		;    
	dec [flag]			;
	jc load_period		;  0...5 ,     
	rrc A				;    2  (   C=0)
	dec [flag]			;
	jc load_period		;  6 ,    
	asr A				;     2  (   C=0)
load_period:	
	dec A				;    1!
	mov [X+array+0],A	; 
	mov reg[X+BASE+1],A	;  

	;  (     )
	; - 1/2  !

	add A,0				; 
.r:	rrc A				;  2 
	add [tmp2],0x10		; 7  tmp2 - = 1,    8 ,   16
	jnc .r				; 1...8 ,  A    1/2   1/256   (.. 0)
	; !!   ,    < 128		
	mov [X+array+2],A	;     
	mov reg[X+BASE+2],0	;    0 

skip_note:
	tst [mode],4		;   
	jnz exit			;      

	jmp again			;   ,         (0)



synth_end::
	;   ,     (     - !)
	mov [ptrR],[ptrW]		; ,    
	;call synth_notes_off	;    (  )
	pop X
	pop A
	reti

exit:
	and [mode],~4	;  
	pop X
	pop A
	reti

.LITERAL
; 	  C   C#   D  D#  E   F   F#  G   G#  A   A#  B (  )
;p_table:	DB 0,246,232,219,207,195,184,174,164,155,146,138,130,0,0,0    ;A880:  24  :12 :16 :146 = 856 (.., -50 )
p_table:	DB 0,239,226,213,201,190,179,169,160,151,142,134,127,0,0,0    ;A880:  24  :12 :16 :142 = 880


;       
;0 -  
	;------------------------------------------------------------------------------------------------
	; : 0xxx xxxx,  1xxx xxxx, ... ... 1xxx xxxx,  1xxx xxxx
	;                .  . .             (. ,  )
	;:    0...7 (3 - A220, 4 - A440 (A5), 5 - A880,)
	;:      1...C -     
	;            "":
	;           0 -   () ( )
	;           0x_D - 
	;           0x0E -  ,
	;           0x1E -   N  ( )
	;           0x2E -      N ( )
	;           0x_F - NOP ( )
	;: 0 -  ... 7 - 
	;: 0 ... 15
	;:   1/128  (128 -  ),   1 
	;          (.. 0 - 1/128, 1 - 1/64, 3 - 1/32, 7 - 1/16, F - 1/8, 1F - 1/4, 3F - 1/2, 7F -  (2 c))
	;------------------------------------------------------------------------------------------------


;------------------------------------------------------------------------------ 
track0::
include "track0.inc"
;------------------------------------------------------------------------------ 
track1::
include "track1.inc"
;------------------------------------------------------------------------------ 
track2::
include "track2.inc"
;------------------------------------------------------------------------------ 
track3::
include "track3.inc"
;------------------------------------------------------------------------------ 
track4::
include "track4.inc"
;------------------------------------------------------------------------------ 
track5::
include "track5.inc"
;------------------------------------------------------------------------------ 
track6::
include "track6.inc"
;------------------------------------------------------------------------------ 
track7::
include "track7.inc"
;------------------------------------------------------------------------------ 
track8::
include "track8.inc"
;------------------------------------------------------------------------------ 
track9::
include "track9.inc"

;------------------------------------------------------------------------------ 
.ENDLITERAL	