;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: Counter16_1INT.asm
;;   Version: 2.5, Updated on 2006/05/15 at 14:54:04
;;  Generated by PSoC Designer ver 4.3  b1884 : 23 June, 2006
;;
;;  DESCRIPTION: Counter16 Interrupt Service Routine
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "Timer8_1.inc"


;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------
export  _Counter16_1_ISR


AREA InterruptRAM (RAM,REL,CON)

;@PSoC_UserCode_INIT@ (Do not change this line.)
;,        

; 
include "Counter8_1.inc"
include "Counter8_2.inc"
include "Counter8_3.inc"
include "Counter8_4.inc"
include "Counter8_5.inc"
include "Counter8_6.inc"

BASE:	equ	Counter8_1_COUNTER_REG	; 1-  (   !)

;    2-   (   )
adr1::	BLK 2
delay:	BLK 2
tmp1:	BLK 1
tmp2:	BLK 1
;@PSoC_UserCode_END@ (Do not change this line.)


AREA UserModules (ROM, REL)

;-----------------------------------------------------------------------------
;  FUNCTION NAME: _Counter16_1_ISR
;
;  DESCRIPTION: Unless modified, this implements only a null handler stub.
;
;-----------------------------------------------------------------------------
;

_Counter16_1_ISR:

   ;@PSoC_UserCode_BODY@ (Do not change this line.)
macro load_code		;     A
	;    ,     adr1,  .
	mov X,[adr1+0]	;   
	mov A,[adr1+1]	;   
	;    
	inc [adr1+0]	 ;  1  
	adc [adr1+1],0 ;       
	;  
	romx
endm
;-----------------------------------------------------------------------------
;  
;-----------------------------------------------------------------------------
	; 
	dec [delay+0]
	sbb [delay+1],0
	jc delay_is_complete
	reti

delay_is_complete:
	; ,    
	mov [delay+0],0	; 0
	mov [delay+1],0


	push A ;  A  X  ,     
	push X ;
	;------------------------------------------------------------------------------------------------
	; : 0xxx xxxx,  1xxx xxxx, ... ... 1xxx xxxx,  1xxx xxxx
	;                .  . .             (. ,  )
	;:    0...7 (4 - A440)
	;:      0 -  ,
	;           1...C -     ,
	;           D -  ,
	;           E - ,
	;           F - 
	;: 0 -  ... 7 - 
	;: 0 ... 15
	;:   1/64  (64 -  ),   1
	;          (.. 0 - 1/64, 1 - 1/32, 3 - 1/16, 7 - 1/8, ... 127 - )
	;------------------------------------------------------------------------------------------------
again:
	; 1- -      
	load_code		;    A
	mov [tmp1],A	; 
	jz end			; 0,    
	asl A			;. . 
;jmp set_note ;debug!
	jnc set_note	; .=0,      

	;    
	mov [delay+0],A	;    (2)
	mov X,[adr1+0]	;     A
	mov A,[adr1+1]	;
	romx			;
	mov [delay+1],A	;    (2)
	asl A			;. . 	
	jc msb			; = 1,   -   
	mov [delay+1],0	; = 0,    ,    0
msb:
	rrc [delay+1]		;  2 ("")  
	rrc [delay+0]		;
	and [delay+1],0x3F	;   

	pop X ;    X  A
	pop A ; 
	reti

set_note: 
	;   (2- )
	load_code		;  ".- "
	mov [tmp2],A	;  
	asl A			;. . 
	jnc end			; 	

	; .   (   4)
	asl A			; 2
	and A,0x3C		;  
	mov X,A			; .  
	; !!      -   		

;mov X,0 ;debug!

	;  (..  Clk)
	mov A,[tmp1]		;   -  A 
	and A,0xF0			; . 4 
	cmp A,0x20			;2 ?
	jnz no_2
	mov A,0x1D			; Clk  2  (Row input 1)
	jmp set_clk
no_2:
	cmp A,0x30			;3 ?
	jnz no_3
	mov A,0x1C			; Clk  3  (Row input 0)
	jmp set_clk
no_3:
	cmp A,0x40			;4 ?
	jnz no_4
	mov A,0x16			; Clk  4  (VC2)
	jmp set_clk
no_4:jmp skip_clk		;     
set_clk:
	M8C_SetBank1
	mov reg[X+BASE+1],A	;  Clk
	M8C_SetBank0
skip_clk:

	;  (..       )
	mov A,[tmp1]		;   
	and A,0x0F			; . 4 
	index p_table		;    
	dec A				;    1!
	mov reg[X+BASE+1],A

	;  (     )
	; - 1/2  !
	;and A,[tmp2]		;   .   (01110000 00110000 00010000 00000000)
	;and A,0x70			;  

	add A,0				; 
r:	rrc A				;  2 
	add [tmp2],0x10		; 7  tmp2 - = 1,    8 ,   16
	jnc r				; 1...8 ,  A    1/2   1/256   (.. 0)
	; !!   ,    < 128		

	mov reg[X+BASE+2],A

	jmp again			;   ,         (0)



end:
;   ,    
;   ,      
mov [adr1+0],(<track1) ;   ,   track1
mov [adr1+1],(>track1) ;   ,   track1
; !!      

pop X ;    X  A (    push)
pop A ;   
reti ;       

; 	  C   C#   D  D#  E   F   F#  G   G#  A   A#  B (  )
p_table:	DB 0,246,232,219,207,195,184,174,164,155,146,138,130,0,0,0


;         .
;0 -  
	;------------------------------------------------------------------------------------------------
	; : 0xxx xxxx,  1xxx xxxx, ... ... 1xxx xxxx,  1xxx xxxx
	;                .  . .             (. ,  )
	;:    0...7 (4 - A440)
	;:      0 -  ,
	;           1...C -     ,
	;           D -  ,
	;           E - ,
	;           F - 
	;: 0 -  ... 7 - 
	;: 0 ... 15
	;:   1/64  (64 -  ),   1
	;          (.. 0 - 1/64, 1 - 1/32, 3 - 1/16, 7 - 1/8, F - 1/4, 1F - 1/2, 3F - , 7F - 2 )
	;------------------------------------------------------------------------------------------------

track1::
DB 41h,F0h,FFh,  41h,E0h,FFh,  41h,D0h,FFh,  41h,C0h,FFh,  41h,B0h,FFh,  41h,A0h,FFh,  41h,90h,FFh,  41h,80h,FFh
DB 42h,F0h,FFh,  42h,E0h,FFh,  42h,D0h,FFh,  42h,C0h,FFh,  42h,B0h,FFh,  42h,A0h,FFh,  42h,90h,FFh,  42h,80h,FFh
DB 0,0
DB 0x21,0x42,0x03,0x14,0x65,0x76,0x07,0x18,0x19,0x1A,0x1B,0x1C,0x10
DB 0x31,0x32,0x03,0x14,0x55,0x36,0x37,0x38,0x39,0x3A,0x3B,0x3C,0x10
DB 0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B,0x2C,0x40
DB 0
   ;@PSoC_UserCode_END@ (Do not change this line.)

   reti


; end of file Counter16_1INT.asm
